var ccCharSettings = ["03C0", "03C1", "03C2", "03C3", "03C4", "03C5", "03C6", "03C7", "03C8", "03C9"];
var ccCharSettings2 = ["03A0", "03A1", "03A2", "03A3", "03A4", "03A5", "03A6", "03A7", "03A8", "03A9"];

function ccSaveOptions(ccEvent) {
  function ccInputCheck(itemText) {
    var itemCheck = "";
    var returnString = "";
    if (String(itemText).length > 4) { itemCheck = String(itemText).substring(0,4); }
      else { itemCheck = itemText; }
    while (String(itemCheck).length < 4) { itemCheck = "0"+itemCheck; }
    itemCheck = String(itemCheck).toUpperCase();
    var itemChar = null;
    var itemIdx = 0;
    for (itemIdx = 0; itemIdx < 4; itemIdx++) {
      itemChar = itemCheck.charCodeAt(itemIdx);
      if (((itemChar > 47) && (itemChar < 58)) || ((itemChar > 64) && (itemChar < 71))) {
        returnString = returnString + itemCheck.charAt(itemIdx); } else { returnString = returnString + "0"; }
    }
    if (returnString == "0000") { returnString = "03C0"; }
    return returnString;
  };
  ccEvent.preventDefault();
  var tempIdx = 0;
  var tempText = "";
  for (tempIdx = 0; tempIdx < 10; tempIdx++) {
    tempText = document.getElementById("cchar"+String(tempIdx)+"input1").value;
    ccCharSettings[tempIdx] = ccInputCheck(tempText);
    tempText = document.getElementById("cchar"+String(tempIdx)+"input2").value;
    ccCharSettings2[tempIdx] = ccInputCheck(tempText);
  }
  browser.storage.local.set({ccCharSettings});
  browser.storage.local.set({ccCharSettings2});
  for (tempIdx = 0; tempIdx < 10; tempIdx++) {
    document.getElementById("cchar"+String(tempIdx)+"input1").value = ccCharSettings[tempIdx];
    document.getElementById("cchar"+String(tempIdx)+"span1").textContent = String.fromCharCode("0x"+ccCharSettings[tempIdx]);
    document.getElementById("cchar"+String(tempIdx)+"input2").value = ccCharSettings2[tempIdx];
    document.getElementById("cchar"+String(tempIdx)+"span2").textContent = String.fromCharCode("0x"+ccCharSettings2[tempIdx]);
  }
};

function ccRestoreOptions() {
  function useStoredSettings(retrievedSettings) {
    var tempIdx = 0;
    var tempItem = retrievedSettings.ccCharSettings;
    if (Array.isArray(tempItem)) {
      var tempLength = tempItem.length;
      if (tempLength > 10) { tempLength = 10 };
      for (tempIdx = 0; tempIdx < tempLength; tempIdx++) {
        document.getElementById("cchar"+String(tempIdx)+"input1").value = tempItem[tempIdx];
        document.getElementById("cchar"+String(tempIdx)+"span1").textContent = String.fromCharCode("0x"+tempItem[tempIdx]);
      }
      tempLength = tempLength - 1;
      for (tempIdx = tempLength; tempIdx < 10; tempIdx++) {
        document.getElementById("cchar"+String(tempIdx)+"input1").value = ccCharSettings[tempIdx];
        document.getElementById("cchar"+String(tempIdx)+"span1").textContent = String.fromCharCode("0x"+ccCharSettings[tempIdx]);
      }
    } else {
      for (tempIdx = 0; tempIdx < 10; tempIdx++) {
        document.getElementById("cchar"+String(tempIdx)+"input1").value = ccCharSettings[tempIdx];
        document.getElementById("cchar"+String(tempIdx)+"span1").textContent = String.fromCharCode("0x"+ccCharSettings[tempIdx]);
      }
    }
    tempItem = retrievedSettings.ccCharSettings2;
    if (Array.isArray(tempItem)) {
      var tempLength = tempItem.length;
      if (tempLength > 10) { tempLength = 10 };
      for (tempIdx = 0; tempIdx < tempLength; tempIdx++) {
        document.getElementById("cchar"+String(tempIdx)+"input2").value = tempItem[tempIdx];
        document.getElementById("cchar"+String(tempIdx)+"span2").textContent = String.fromCharCode("0x"+tempItem[tempIdx]);
      }
      tempLength = tempLength - 1;
      for (tempIdx = tempLength; tempIdx < 10; tempIdx++) {
        document.getElementById("cchar"+String(tempIdx)+"input2").value = ccCharSettings2[tempIdx];
        document.getElementById("cchar"+String(tempIdx)+"span2").textContent = String.fromCharCode("0x"+ccCharSettings2[tempIdx]);
      }
    } else {
      for (tempIdx = 0; tempIdx < 10; tempIdx++) {
        document.getElementById("cchar"+String(tempIdx)+"input2").value = ccCharSettings2[tempIdx];
        document.getElementById("cchar"+String(tempIdx)+"span2").textContent = String.fromCharCode("0x"+ccCharSettings2[tempIdx]);
      }
    }
  };

  function onError(e) {
    chrome.notifications.create({
      "type": "basic",
      "iconUrl": chrome.extension.getURL("icons/customcharacters-48.png"),
      "title": chrome.i18n.getMessage("RestoreErrorTitle"),
      "message": chrome.i18n.getMessage("RestoreErrorMessage")
    });
  };

  var ccStoredSettings = browser.storage.local.get();
  ccStoredSettings.then(useStoredSettings, onError);
};

document.addEventListener("DOMContentLoaded", ccRestoreOptions);
document.querySelector("form").addEventListener("submit", ccSaveOptions);
